discussion/discussion/urls.py
from django.contrib import admin
from django.urls import include, path

urlpatterns = [
    path('todolist/', include('todolist.urls')),
    path('admin/', admin.site.urls),
]

discussion/todolist/urls.py
from django.urls import path
# import the views.py from the same folder
from . import views

app_name = 'todolist'

urlpatterns = [
    path('index', views.index, name = 'index'),
    path('<int:todoitem_id>/', views.todoitem, name = "viewtodoitem"),
    path('register', views.register, name = "register"),
    path('change_password', views.change_password, name = "change_password"),
    path('login', views.login_user, name = "login"),
    path('logout', views.logout_user, name = "logout"),
    path('add_task', views.add_task, name = "add_task")
]

discussion/todolist/models.py
from django.db import models

# Create your models here.
from django.contrib.auth.models import User

class ToDoItem(models.Model):
    task_name = models.CharField(max_length=50)
    description = models.CharField(max_length=200)
    status = models.CharField(max_length=50, default = "pending")
    date_created = models.DateTimeField('date created')
    user = models.ForeignKey(User, on_delete = models.RESTRICT, default = "")

discussion/todolist/forms.py
from django import forms

class LoginForm(forms.Form):
    username = forms.CharField(label = "username", max_length = 20)
    password = forms.CharField(label = "password", max_length = 20)

class AddTaskForm(forms.Form):
    task_name = forms.CharField(label = 'task_name', max_length = 50)
    description = forms.CharField(label = 'description', max_length = 200)

discussion/todolist/views.py
from django.shortcuts import render, redirect, get_object_or_404

# Create your views here.

# THe from keyword allows importing of necessary classes/ modules, methods and others files needed in our application from the django.http package while the import keyword defines what we are importing from the package
from django.http import HttpResponse
# Local imports
from .models import ToDoItem
# to use the template created:
from django.template import loader
# import the buil in user model
from django.contrib.auth.models import User
# import the authenticate function
from django.contrib.auth import authenticate, login, logout
from django.forms.models import model_to_dict
from .forms import LoginForm, AddTaskForm
from django.utils import timezone
def index(request):
    todoitem_list = ToDoItem.objects.filter(user_id = request.user.id)
    # template = loader.get_template("index.html")
    context = {
        'todoitem_list': todoitem_list,
        'user': request.user
    }
    # output = ", ".join([todoitem.task_name for todoitem in todoitem_list])
    return render(request, "index.html", context)

def todoitem(request, todoitem_id):
    # response = f"You are viewing the details of {todoitem_id}"
    # return HttpResponse(response)
    todoitem = get_object_or_404(ToDoItem, pk = todoitem_id)

    return render(request, "todoitem.html", model_to_dict(todoitem))

# this function is responsible for registering on our application

def register(request):
    users = User.objects.all()
    is_user_registered = False

    user = User()
    user.username = "johndoe"
    user.first_name = "john"
    user.last_name = "doe"
    user.email = "john@mail.com"
    user.set_password("john1234")
    user.is_staff = False
    user.is_active = True

    for indiv_user in users:
        if indiv_user.username == user.username:
            is_user_registered = True
            break

    if is_user_registered == False:
        user.save()

    # to save our user

    context = {
        'is_user_registered' : is_user_registered,
        'first_name' : user.first_name,
        'last_name' : user.last_name
    }
    return render(request, "register.html", context)

def change_password(request):
    
    is_user_authenticated = False

    user = authenticate(username = "johndoe", password = "john1234")

    if user is not None:
        authenticated_user = User.objects.get(username = 'johndoe')
        authenticated_user.set_password("johndoe12345")
        authenticated_user.save()

        is_user_authenticated = True
    
    context = {
        "is_user_authenticated" : is_user_authenticated
    }

    return render(request, "change_password.html", context)

def login_user(request):
    context = {}

    if request.method == "POST":
        form = LoginForm(request.POST)

        if form.is_valid() == False:
            form = LoginForm()
        else:
            username = form.cleaned_data["username"]
            password = form.cleaned_data['password']

            user = authenticate(username = username, password = password)

            if user is not None:
                context = {
                    'username' : username,
                    'password' : password
                }
                login(request, user)
                return redirect("todolist:index")
            else:
                context = {
                    'error' : True
                }
            
    return render(request, "login.html", context)


    # username = 'johndoe'
    # password = 'johndoe12345'

    # # is_user_authenticated = False
    
    # user = authenticate(username = username, password = password)

    

def logout_user(request):
    logout(request)
    return redirect("todolist:index")

def add_task(request):
    context = {}

    if request.method == 'POST':
        form = AddTaskForm(request.POST)

        if form.is_valid() == False:
            form = AddTaskForm()
        else:
            task_name = form.cleaned_data['task_name']
            description = form.cleaned_data['description']

            duplicates = ToDoItem.objects.filter(task_name = task_name, user_id = request.user.id)

            if not duplicates:
                # create an object base on the Todoitem model and saves to the  record in the database
                ToDoItem.objects.create(task_name = task_name, description = description, date_created = timezone.now(), user_id = request.user.id )

                return redirect("todolist:index")
            
            else:
                context = {
                    'error': True
                }

    return render(request, "add_task.html", context)

discussion/templates/base.html
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>{%block title %}To Do App{% endblock %}</title>
    <!-- Bootssstraaap -->
    <link href="https://cdn.jsdelivr.net/npm/bootstrap@5.3.0-alpha2/dist/css/bootstrap.min.css" rel="stylesheet" integrity="sha384-aFq/bzH65dt+w6FI2ooMVUpc+21e0SRygnTpmBvdBgSdnuTN7QbdgL+OapgHtvPp" crossorigin="anonymous">
</head>
<body>
    <!-- <h1>Hello Batch 278!</h1> -->
    <!-- The inlcude keyword unlike the extends keyword allows to inject specific templates in certain sections of page -->
    {% include "navbar.html" %}

    {% block content%}
        <!-- block denotes a placeholder -->
    {% endblock %}
    <!-- ssscrripttt -->

    <script src="https://cdn.jsdelivr.net/npm/bootstrap@5.3.0-alpha2/dist/js/bootstrap.bundle.min.js" integrity="sha384-qKXV1j0HvMUeCBQ+QVp7JcfGl760yU08IQ+GpUo5hlbpg51QRiuqHAJz8+BrxE/N" crossorigin="anonymous"></script>
</body>
</html>

discussion/templates/navbar.html
<nav class="navbar navbar-expand-lg bg-dark">
    <div class="container-fluid ">
      <a class="navbar-brand text-white" href="{% url 'todolist:index'%}">To Do App</a>
      <button class="navbar-toggler" type="button" data-bs-toggle="collapse" data-bs-target="#navbarNav" aria-controls="navbarNav" aria-expanded="false" aria-label="Toggle navigation">
        <span class="navbar-toggler-icon"></span>
      </button>
      <div class="collapse navbar-collapse" id="navbarNav">
        <ul class="navbar-nav ms-auto ">
          <li class="nav-item">
            <a class="nav-link active text-white" aria-current="page" href="{% url 'todolist:index'%}">Home</a>
          </li>
          <li class="nav-item">
            <a class="nav-link text-white" href="{% url 'todolist:add_task'%}">Add Task</a>
          </li>
          <li class="nav-item">
            <a class="nav-link text-white" href="{% url 'todolist:login'%}">Login</a>
          </li>
          <li class="nav-item">
            <a class="nav-link text-white" href="{% url 'todolist:logout'%}">Logout</a>
          </li>
        </ul>
      </div>
    </div>
  </nav>

discussion/todolist/templates/add_task.html
{% extends 'base.html' %}

{% block title%}Add Task{% endblock %}

{% block content %}
    <div class="container">
        <div class="row">
            <div class="col-6 offset-3">
                {% if error == True %}
                    <p class="text-danger">Duplicate Task Found!</p>
                {% endif %}
                <form action="{% url 'todolist:add_task' %}" method="POST">
                    
                    {% csrf_token %}

                    <div class="mb-3">
                        <label for="task_name">Task Name: </label>
                        <input class="form-control" id="task_name" type="text" name="task_name" value="{{ task_name }}" maxlength="50" required>
                    </div>

                    <div class="mb-3">
                        <label for="description">Description: </label>
                        <textarea class="form-control" name="description" value="{{ description }}" required></textarea>
                    </div>

                    <div class="text-center">
                        <input class="btn btn-success" type="submit" value="Add Task">
                    </div>

                </form>
            </div>
        </div>

    </div>

{% endblock %}

discussion/todolist/templates/change_password.html
{% if is_user_authenticated == False %}
    <h1>Invalid User Credential!</h1>
    <p>Check if the username and password is correct!</p>
{% else %}
    <h1>User password successfully updated!</h1>
    <p>The password has been successfully updated!</p>
{% endif %}

discussion/todolist/templates/index.html
{% extends 'base.html' %}

{%block title%}Home{%endblock%}

{% block content %}

{%if todoitem_list and user.is_anonymous == False %}
    <h1 class = "text-center my-3">Welcome {{user.first_name}} {{user.last_name}}!</h1>
    <div class = "container">
        <div class ="row">
            <h3 class="text-center mb-3">My Tasks</h3>
            <ul class="list-group text-center col-lg-4 offset-lg-4">
                {% for todoitem in todoitem_list %}
                    <li class="list-group-item"><a class="text-decoration-none" href = "{% url 'todolist:viewtodoitem' todoitem.id%}">{{todoitem.task_name}}</a></li>
                {% endfor%}    
            </ul>
        </div>
    </div>
    
{% elif todoitem_list.count == 0 and user.is_anonymous == False %}
    <h1>Welcome {{user.first_name}} {{user.last_name}}!</h1>    
    <p>No tasks have been created.</p>
{% else %}
    <h1 class = "text-center my-3">You are not authorized to access this page.</h1>
    <p class = "text-center my-3">Kindly login <a href = "{% url 'todolist:login' %}">here</a></p>
{% endif %}

{% endblock %}

discussion/todolist/templates/login.html
{% extends "base.html" %}

{% block title %} Login {% endblock %}

{% block content %}
    <h1 class = "text-center my-3">Login Form</h1>
    <div class="container">
        <div class="row">
            <div class="col-6 offset-3">
                {% if error == True %}
                    <p class="text-danger">Invalid credentials, please check your username and password</p>
                {% endif %}
                <form action="{% url 'todolist:login' %}" method="POST">
                    <!-- This template tag provides protection against cross site request forgeries (CSRF) -->
                    {% csrf_token %}
                    <div class="mb-3">
                      <label for="username" class="form-label">Username:</label>
                      <input 
                      type="text" 
                      class="form-control" 
                      id="username"
                      value = "{{username}}"
                      name = "username"
                      maxlength="20"
                      required
                      >
                    </div>
                    <div class="mb-3">
                      <label for="password" class="form-label">Password:</label>
                      <input 
                      type="password" 
                      class="form-control" 
                      id="password"
                      name = "password"
                      value= "{{password}}"
                      maxlength="20"
                      required
                      >
                    </div>                    
                    <button type="submit" class="btn btn-primary">Login</button>
                  </form>
            </div>
        </div>
    </div>
{% endblock %}

discussion/todolist/templates/register.html
{% if is_user_registered == False %}

    <h1>User Successfully Created!</h1>

    <p>The account for {{first_name}} {{last_name}} has benn successfuly registered</p>

{% else %}
    <h1> Duplicate User Found!</h1>
    <p>A duplicate user has benn found, user creation unsuccessful</p>


{% endif %}

discussion/todolist/templates/todoitem.html
<h1>{{task_name}}</h1>
<h3>Description:</h3>
<p>{{description}}</p>
<h3>Status:</h3>
<p>{{status}}</p>

<a href="{% url 'todolist:index' %}">Back to index page!</a>